from model import Action,Bomb,Bonus,BonusType,Explosion,Obstacle,Player,Rules,Strategy,World,WorldObject,WorldObjectType

class MyStrategy(Strategy):

    def __init__(self):
        pass

    def getAction(self, player, world):
        rules = self.getRules()
        action = Action()

        dir = 1.0 if (player.playerId == 0 or player.playerId == 3) else -1.0

        action.speedX = dir * rules.PLAYER_MAX_SPEED
        action.speedY = 0.0

        anyBombPlaced = False
        for b in world.getBombs():
            if b.getOwner() == player.playerId:
                anyBombPlaced = True

        anyWallNearby = False
        for w in world.getObstacles():
            if w.type == WorldObjectType.BrickWall and abs(w.getX()-player.getX()) + abs(w.getY()-player.getY()) < 1.5 * rules.BRICK_SIZE:
                anyWallNearby = True

        anyExplosionPresent = False
        for e in world.getExplosions():
            if player.playerId in e.getCreators():
                anyExplosionPresent = True

        if anyExplosionPresent:
            action.speedX = 0.0
            action.speedY = 0.0
        elif anyBombPlaced:
            action.speedX *= -1
        elif anyWallNearby:
            action.drop = True

        return action
